# The LearningOnline Network
# Printout
#
# $Id: lonprintout.pm,v 1.99 2002/12/11 22:06:55 albertel Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
# (Internal Server Error Handler
#
# (Login Screen
# 5/21/99,5/22,5/25,5/26,5/31,6/2,6/10,7/12,7/14,
# 1/14/00,5/29,5/30,6/1,6/29,7/1,11/9 Gerd Kortemeyer)
#
# 3/1/1 Gerd Kortemeyer)
#
# 3/1 Gerd Kortemeyer
#
# 9/17 Alex Sakharuk
#
package Apache::lonprintout;

use strict;
use Apache::Constants qw(:common :http);
use Apache::lonxml;
use Apache::lonnet;
use Apache::loncommon;
use Apache::inputtags;
use Apache::grades;
use Apache::edit;
use Apache::File();
use Apache::lonnavmaps;
use POSIX qw(strftime);
use GDBM_File;


my %hash;
my $LaTeXwidth = 0;

sub headerform {
    my $r = shift;
    $r->print(<<ENDHEADER);
<html>
<head>
<title>LON-CAPA output for printing</title>
</head>
<body bgcolor="FFFFFF">
<form method="post" enctype="multipart/form-data" action="/adm/printout" name="printform">
ENDHEADER
    if ($ENV{'request.role'}=~m/^cc\./ or $ENV{'request.role'}=~m/^in\./ or $ENV{'request.role'}=~m/^ta\./) { 
    $r->print(<<ENDHEADER1);
<b>Path to current document: </b><tt>$ENV{'form.postdata'}</tt><p>
ENDHEADER1
}
}


sub menu_for_output {
    my $r = shift;
    my ($title_for_single_resource,$title_for_sequence,$title_for_main_map) = &details_for_menu;
    my $assignment = $title_for_sequence;
    if ($title_for_single_resource ne '') {$title_for_single_resource = '"'.$title_for_single_resource.'"';}
    if ($title_for_sequence ne '') {$title_for_sequence = '"'.$title_for_sequence.'"';}
    if ($title_for_main_map ne '') {$title_for_main_map = '"'.$title_for_main_map.'"';}
    my $subdir_to_print = $ENV{'form.postdata'};
    $subdir_to_print =~ m/\/([^\/]+)$/;
    $subdir_to_print =~ s/$1//;
    $r->print(<<ENDMENUOUT1);
<h1>What do you want to print? Make a choice.</h1><br />
<input type="hidden" name="phase" value="two">
<input type="hidden" name="url" value="$ENV{'form.postdata'}">
<input type="hidden" name="assignment" value="$assignment">
<input type="radio" name="choice" value="Standard LaTeX output for current document" checked>  Current document <b>$title_for_single_resource</b>
(prints what you just saw on the screen)<br />
ENDMENUOUT1
    if ($ENV{'form.postdata'}=~/\/res\//) {
	$r->print(<<ENDMENUOUT2);
<input type="radio" name="choice" value="Standard LaTeX output for the primary sequence">  Problem(s) from <b>$title_for_sequence</b><br />
<input type="radio" name="choice" value="Standard LaTeX output for whole primary sequence">  Problem(s) plus page(s) or html/xml file(s) from <b>$title_for_sequence</b><br />
ENDMENUOUT2
    }
    if (($ENV{'request.role'}=~m/^cc\./ or $ENV{'request.role'}=~m/^in\./ or $ENV{'request.role'}=~m/^ta\./) and ($ENV{'form.postdata'}=~/\/res\//)) { 
	$r->print(<<ENDMENUOUT6);
<input type="radio" name="choice" value="Standard LaTeX output for the top level sequence">  All problems in this course (<b>warning:</b> this may be time consuming) <br />
<br />
<input type="radio" name="choice" value="All class print">  All problems from <b>$title_for_sequence</b> for selected students<br /><br />
ENDMENUOUT6
    }
      my $subdirtoprint = &Apache::lonnet::filelocation("",$ENV{'form.url'});
      $subdirtoprint =~ s/\/[^\/]+$//;
      if ((&Apache::lonnet::allowed('bre',$subdirtoprint) eq 'F') and ($ENV{'form.postdata'}=~/\.(problem|exam|quiz|assess|survey|form|library|page|xml|html|htm|xhtml|xhtm)/)) {
	  $r->print(<<ENDMENUOUT4);
  <input type="radio" name="choice" value="Subdirectory print">  Problems from current subdirectory <b>$subdir_to_print</b><br />
ENDMENUOUT4
      }
    $r->print(<<ENDMENUOUT5);
<br /><hr /><br />
<h1>And what page format do you prefer?</h1>
<table>
 <tr>
   <td>
     <input type="radio" name="layout" value="CBI"> Landscape <br />
     <input type="radio" name="layout" value="CAPA" checked>  Portrait <br />
   </td>
   <td>&nbsp;</td>
   <td rawspan="2">
     Number of columns: <select name="numberofcolumns">
                         <option> 1 </option>
                         <option selected> 2 </option>
                        </select> 
   </td>
   <td rawspan="2">
     Paper size (format [width x height]): <select name="papersize">
                                            <option selected> Letter [8 1/2x11 in] </option>
                                            <option> Legal [8 1/2x14 in] </option>
                                            <option> Ledger/Tabloid [11x17 in] </option>
                                            <option> Executive [7 1/2x10 in] </option>
                                            <option> A2 [420x594 mm] </option>
                                            <option> A3 [297x420 mm] </option>
                                            <option> A4 [210x297 mm] </option>
                                            <option> A5 [148x210 mm] </option>
                                            <option> A6 [105x148 mm] </option>
                                           </select> 
   </td>
 </tr>
</table>
</br> 
<input type="submit" value="Submit your choice">
ENDMENUOUT5
}


sub sequence_content_menu {
    my ($key_to,$r) = @_;
    my $symbolic = &Apache::lonnet::symbread($ENV{'form.url'});
    my @sequence = split('___',$symbolic);
    my $primary_sequence = '/res/'.$sequence[0];   
    my @master_seq = &coming_from_hash($primary_sequence,$sequence[0]);
    my @master_seq_view = @master_seq;
    for (my $i=0;$i<=$#master_seq_view;$i++) {
	$master_seq_view[$i]=~/\/([^\/]+)$/;
	$master_seq_view[$i]=$1;
    }
    $r->print(<<ENDMENUOUT1);
<input type="hidden" name="url" value="$ENV{'form.url'}">
<input type="hidden" name="choice" value="$ENV{'form.choice'}">
<input type="hidden" name="layout" value="$ENV{'form.layout'}">
<input type="hidden" name="papersize" value="$ENV{'form.papersize'}">
<input type="hidden" name="assignment" value="$ENV{'form.assignment'}">
<input type="hidden" name="numberofcolumns" value="$ENV{'form.numberofcolumns'}">
<h1>Mark item(s) which you want to print</h1>
<script>
    function checkall() {
	for (i=0; i<document.forms.printform.elements.length; i++) {
            if 
          (document.forms.printform.elements[i].name.indexOf('whatfile')==0) {
	      document.forms.printform.elements[i].checked=true;
            }
        }
    }
    function uncheckall() {
	for (i=0; i<document.forms.printform.elements.length; i++) {
            if 
          (document.forms.printform.elements[i].name.indexOf('whatfile')==0) {
	      document.forms.printform.elements[i].checked=false;
            }
        }
    }
</script>
<input type=button onClick="checkall()" value="Check All">&nbsp;
<input type=button onClick="uncheckall()" value="Uncheck">
<p>
ENDMENUOUT1
    my $inc=0; 
    for (my $i=0;$i<=$#master_seq_view;$i++) {
      if ($key_to==1 && $master_seq_view[$i]=~/\.(problem|exam|quiz|assess|survey|form|library)$/) {
	$r->print('<br /><input type=checkbox name="whatfile'.$inc.'" value="'.$master_seq[$i].'"> '."\n".
                  $master_seq_view[$i]);
        $inc++;
    } elsif ($key_to==0 && $master_seq_view[$i]=~/\.(problem|exam|quiz|assess|survey|form|library|xml|htm|html|page)$/) {
	$r->print('<br /><input type=checkbox name="whatfile'.$inc.'" value="'.$master_seq[$i].'"> '.
                  $master_seq_view[$i]);
        $inc++;
      }
    }
    $r->print(<<ENDMENUOUT2);
<br />
<input type="hidden" name="numberoffiles" value="$inc">
<input type="hidden" name="phase" value="three">
<input type="submit" value="Submit">
ENDMENUOUT2

}


sub problem_choice_menu {
    my $r = shift;
    my $subdirtoprint = &Apache::lonnet::filelocation("",$ENV{'form.url'});
    $subdirtoprint =~ s/\/[^\/]+$//;
    my @list_of_files = ();
    if ($ENV{'request.role'}=~m/^au\./ or $ENV{'request.role'}=~m/^ca\./) {
	$subdirtoprint =~ s/^[^~]*~(\w+)\//\/home\/$1\/public_html\//;
    } else {
	$subdirtoprint =~ s/.*(\/res\/)/$1/;
    }
    my @content_directory = ();
    if ($ENV{'request.role'}=~m/^au\./ or $ENV{'request.role'}=~m/^ca\./) {
	@content_directory = &Apache::lonnet::dirlist($subdirtoprint,$ENV{'user.domain'}, $ENV{'user.name'},'');
    } else {
	@content_directory = &Apache::lonnet::dirlist($subdirtoprint);
    }
    for (my $iy=0;$iy<=$#content_directory;$iy++) {
	my @tempo_array = split(/&/,$content_directory[$iy]);
	if ($tempo_array[0] =~ m/^[^\.]+\.(problem|exam|quiz|assess|survey|form|library)$/) {
	    push(@list_of_files,$tempo_array[0]);
	}
    }
    $subdirtoprint =~ s/\/$//;
    for (my $i=0;$i<=$#list_of_files;$i++) {
	$list_of_files[$i] = $subdirtoprint.'/'.$list_of_files[$i];
    }
    $r->print(<<ENDMENUOUT1);
<input type="hidden" name="url" value="$ENV{'form.url'}">
<input type="hidden" name="choice" value="$ENV{'form.choice'}">
<input type="hidden" name="layout" value="$ENV{'form.layout'}">
<input type="hidden" name="numberofcolumns" value="$ENV{'form.numberofcolumns'}">
<h1>Mark problems which you want to print</h1>
<script>
    function checkall() {
	for (i=0; i<document.forms.printform.elements.length; i++) {
            if 
          (document.forms.printform.elements[i].name.indexOf('whattoprint')==0) {
	      document.forms.printform.elements[i].checked=true;
            }
        }
    }


    function uncheckall() {
	for (i=0; i<document.forms.printform.elements.length; i++) {
            if 
          (document.forms.printform.elements[i].name.indexOf('whattoprint')==0) {
	      document.forms.printform.elements[i].checked=false;
            }
        }
    }
</script>
<input type=button onClick="checkall()" value="Check All">&nbsp;
<input type=button onClick="uncheckall()" value="Uncheck">
<p>
ENDMENUOUT1
    my $i=0;
    foreach my $file (@list_of_files) {
	$r->print('<br /><input type=checkbox name="whattoprint'.$i.'" value="'.$file.'"> '.
                  $file);
	$i++;
    }
    $r->print(<<ENDMENUOUT2);
<br />
<input type="hidden" name="papersize" value="$ENV{'form.papersize'}">
<input type="hidden" name="numberofproblems" value="$i">
<input type="hidden" name="phase" value="three">
<input type="submit" value="Submit">
ENDMENUOUT2
}


sub additional_class_menu {
    my $r = shift;
    $r->print(<<ENDMENUOUT1);
<input type="hidden" name="url" value="$ENV{'form.url'}">
<input type="hidden" name="choice" value="$ENV{'form.choice'}">
<input type="hidden" name="layout" value="$ENV{'form.layout'}">
<input type="hidden" name="numberofcolumns" value="$ENV{'form.numberofcolumns'}">
<input type="hidden" name="assignment" value="$ENV{'form.assignment'}">
<h1>Select student(s) whose assignment you want to print</h1>
ENDMENUOUT1
    my %courselist=&Apache::lonnet::dump(
                   'classlist',
		   $ENV{'course.'.$ENV{'request.course.id'}.'.domain'},
		   $ENV{'course.'.$ENV{'request.course.id'}.'.num'});
    my $now=time;
    $r->print(<<ENDDISHEADER);
<script>
    function checkall() {
	for (i=0; i<document.forms.printform.elements.length; i++) {
            if 
          (document.forms.printform.elements[i].name.indexOf('whomtoprint')==0) {
	      document.forms.printform.elements[i].checked=true;
            }
        }
    }

    function checksec() {
	for (i=0; i<document.forms.printform.elements.length; i++) {
            if 
          (document.forms.printform.elements[i].value.indexOf
           (document.forms.printform.chksec.value)==0) {
	      document.forms.printform.elements[i].checked=true;
            }
        }
    }

    function uncheckall() {
	for (i=0; i<document.forms.printform.elements.length; i++) {
            if 
          (document.forms.printform.elements[i].name.indexOf('whomtoprint')==0) {
	      document.forms.printform.elements[i].checked=false;
            }
        }
    }
</script>
<input type=button onClick="checkall()" value="Check All">&nbsp;
<input type=button onClick="checksec()" value="Type Section/Group then click">
<input type=text size=5 name=chksec>&nbsp;
<input type=button onClick="uncheckall()" value="Uncheck">
<p>
ENDDISHEADER
    my $i = 0;
    foreach (sort keys %courselist) {
        my ($end,$start)=split(/\:/,$courselist{$_});
        my $active=1;
        if (($end) && ($now>$end)) { $active=0; }
        if ($active) {
           my ($sname,$sdom)=split(/\:/,$_);
           my %reply=&Apache::lonnet::get('environment',
              ['firstname','middlename','lastname','generation'],
              $sdom,$sname);
           my $section=&Apache::lonnet::usection
	       ($sdom,$sname,$ENV{'request.course.id'});
           $r->print(
        '<br /><input type=checkbox name="whomtoprint'.$i.'" value="'.$section.':'.$_.'"> '.
		      $reply{'firstname'}.' '. 
                      $reply{'middlename'}.' '.
                      $reply{'lastname'}.' '.
                      $reply{'generation'}.
                      ' ('.$_.') '.$section);
	   $i++;
        } 
    }
    $r->print(<<ENDMENUOUT2);
<br />Number of blank pages to add: <select name="addedpages"><option selected>0</option>
                                                              <option>1</option>
                                                              <option>2</option>
                                                              <option>3</option>
                                    </select>
<br /> 
<input type="hidden" name="papersize" value="$ENV{'form.papersize'}">
<input type="hidden" name="numberofstudents" value="$i">
<input type="hidden" name="phase" value="three">
<input type="submit" value="Submit">
ENDMENUOUT2
}


sub additional_print_menu { 
    my $r = shift;
    my $what_to_print = '';
    for (my $i=0; $i<$ENV{'form.numberofstudents'};$i++) {
	$what_to_print .= '<input type="hidden" name="whomtoprint'.$i.'" value="'.$ENV{'form.whomtoprint'.$i}.'">';
    }
    for (my $i=0; $i<$ENV{'form.numberofproblems'};$i++) {
	$what_to_print .= '<input type="hidden" name="whattoprint'.$i.'" value="'.$ENV{'form.whattoprint'.$i}.'">';
    }
    for (my $i=0; $i<$ENV{'form.numberoffiles'};$i++) {
	$what_to_print .= '<input type="hidden" name="whatfile'.$i.'" value="'.$ENV{'form.whatfile'.$i}.'">';
    }
    $r->print(<<ENDMENUOUT);
    $what_to_print
<input type="hidden" name="url" value="$ENV{'form.url'}">
<input type="hidden" name="choice" value="$ENV{'form.choice'}">
<input type="hidden" name="layout" value="$ENV{'form.layout'}">
<input type="hidden" name="papersize" value="$ENV{'form.papersize'}">
<input type="hidden" name="numberofstudents" value="$ENV{'form.numberofstudents'}">
<input type="hidden" name="numberofproblems" value="$ENV{'form.numberofproblems'}">
<input type="hidden" name="numberoffiles" value="$ENV{'form.numberoffiles'}">
<input type="hidden" name="numberofcolumns" value="$ENV{'form.numberofcolumns'}">
<input type="hidden" name="assignment" value="$ENV{'form.assignment'}">
<input type="hidden" name="addedpages" value="$ENV{'form.addedpages'}">
Define one column layout parameters: <br />
<b>Width</b>: <input type="text" name="width" width="8" value="9cm"> <br />
<b>Height</b>: <input type="text" name="height" width="8" value="25.9cm"> <br />
<b>Left margin</b>: <input type="text" name="leftmargin" width="8" value="-0.57in"> <br />
<input type="hidden" name="phase" value="four">
<input type="submit" value="Submit">
</form>
</body>
</html>
ENDMENUOUT
}


sub output_data {
    my $r = shift;
    $r->print(<<ENDPART);
<html>
<head>
<title>LON-CAPA output for printing</title>
</head>
<body bgcolor="FFFFFF">
<hr>
ENDPART

    my $choice = $ENV{'form.choice'};
    my $layout = $ENV{'form.layout'};
    my $numberofcolumns = $ENV{'form.numberofcolumns'};  
    my $papersize = $ENV{'form.papersize'};          
    my $laystyle = 'book';
    my $assignment =  $ENV{'form.assignment'};
    if ($choice eq 'Subdirectory print') {
	if ($ENV{'form.layout'} eq '') {$layout = 'CAPA';}
	if ($ENV{'form.papersize'} eq '') {$papersize = 'Letter [8 1/2x11 in]';}
	if ($ENV{'form.numberofcolumns'} eq '') {$numberofcolumns = 2;}
    }
    if (($choice eq 'Standard LaTeX output for current document') && ($ENV{'request.role'}=~m/^au\./ or $ENV{'request.role'}=~m/^ca\./)) {
	if ($ENV{'form.layout'} eq '') {$layout = 'CAPA';}
	if ($ENV{'form.papersize'} eq '') {$papersize = 'Letter [8 1/2x11 in]';}
	if ($ENV{'form.numberofcolumns'} eq '') {$numberofcolumns = 2;}
    }
    my $result = '';
    my $number_of_columns = 1; #used only for pages to determine the width of the cell
    my $selectionmade = '';
    my ($textwidth,$textheight,$oddoffset,$evenoffset) = &page_format($papersize,$layout,$numberofcolumns);
    my $LaTeXwidth;
 
    if ($textwidth=~/(\d+\s*cm)/) {
	$LaTeXwidth = $1*10;
    } elsif ($textwidth=~/(\d+\s*mm)/) {
	$LaTeXwidth = $1;
    }
    if ($choice eq 'Standard LaTeX output for current document') {
      #-- single document - problem, page, html, xml  
      $selectionmade = 1;
      if ($ENV{'form.url'}=~/\.(problem|exam|quiz|assess|survey|form|library|page|xml|html|htm|xhtml|xhtm)$/) {
        my %moreenv;
        $moreenv{'form.grade_target'}='tex';
        if (&Apache::lonnet::allowed('bre',$ENV{'form.url'})) {
	  $ENV{'form.url'}=~s/http:\/\/[^\/]+//;
        }
        $moreenv{'request.filename'}=$ENV{'form.url'};
        $moreenv{'form.textwidth'}=$LaTeXwidth;
        &Apache::lonnet::appenv(%moreenv);
        my $texversion=&Apache::lonnet::ssi($ENV{'form.url'});
        &Apache::lonnet::delenv('form.grade_target','form.textwidth','form.counter');
        $result .= $texversion;
        if ($ENV{'form.url'}=~m/\.page\s*$/) {
	  ($result,$number_of_columns) = &page_cleanup($result);
        }
      } else {
	  $result='\documentclass[letterpaper]{article}\usepackage{calc}\begin{document}Printout of this type of document is currently not supported: ';
	  if ($ENV{'form.url'}=~/\/(aboutme|syllabus|bulletinboard|smppg)$/) {
	      $result.=$1;
	  } else {
	      $result.=$ENV{'form.url'};
	  }
	  $result.=' \end{document}'
      }
    } elsif ($choice eq 'Standard LaTeX output for the primary sequence' or 
             $choice eq 'Standard LaTeX output for whole primary sequence') {
      #-- minimal sequence to which the current document belongs
        #-- where is the primary sequence containing file?
        my @master_seq = ();
	for (my $i=0; $i<$ENV{'form.numberoffiles'};$i++) {
	    if ($ENV{'form.whatfile'.$i}=~/\S/) {
		push @master_seq,$ENV{'form.whatfile'.$i};
	    }
	}
        #-- produce an output string
	my $flag_latex_header_remove = 'NO';
	my $flag_page_in_sequence = 'NO';
	for (my $i=0;$i<=$#master_seq;$i++) {
           my ($urlp,$symb) = split /&&/, $master_seq[$i];		
	    if ($choice eq 'Standard LaTeX output for the primary sequence') {
              $selectionmade = 2;
	    } elsif ($choice eq 'Standard LaTeX output for whole primary sequence') {
              $selectionmade = 3;
	    }
	   my %moreenv;
	   $moreenv{'form.grade_target'}='tex';
	   $moreenv{'form.textwidth'}=$LaTeXwidth;
	   &Apache::lonnet::appenv(%moreenv);
	   #&Apache::lonnet::logthis("Trying to get $urlp with symb $symb");
	   my $texversion=&Apache::lonnet::ssi($urlp,('symb'=>$symb));
	   &Apache::lonnet::delenv('form.grade_target','form.textwidth');
	   if ($urlp =~ m/\.page/) {
	     ($texversion,my $number_of_columns_page) = &page_cleanup($texversion);
	     if ($number_of_columns_page > $number_of_columns) {$number_of_columns=$number_of_columns_page;} 
	     $texversion =~ s/\\end{document}\d*/\\end{document}/;
	     $flag_page_in_sequence = 'YES';
	   } 
	   if ($flag_latex_header_remove ne 'NO') {
	     $texversion = &latex_header_footer_remove($texversion);
	   } else {
	     $texversion =~ s/\\end{document}//;
	   }
	   $result .= $texversion;         
	   $flag_latex_header_remove = 'YES';   
	}
	&Apache::lonnet::delenv('form.counter');
	if ($flag_page_in_sequence eq 'YES') {$result =~ s/\\usepackage{calc}/\\usepackage{calc}\\usepackage{longtable}/;}	
	$result .= '\end{document}';
    }  elsif ($choice eq 'Standard LaTeX output for the top level sequence') {
        # where is the main sequence of the course?
	$selectionmade = 4;
	my $main_seq = '/res/'.$ENV{'request.course.uri'};
	my @file_seq = &coming_from_hash_whole($main_seq);
	my $flag_latex_header_remove = 'NO';
        #-- produce an output string
	for (my $i=0;$i<=$#file_seq;$i++) {
            my ($urlp,$symb) = split /&&/, $file_seq[$i];
	    $urlp=~s/\/home\/httpd\/html//;	    
            if ($urlp=~m/\.(problem|exam|quiz|assess|survey|form|library)/) {
		my %moreenv;
		$moreenv{'form.grade_target'}='tex';
		$moreenv{'form.textwidth'}=$LaTeXwidth;
		&Apache::lonnet::appenv(%moreenv);
		my $texversion=&Apache::lonnet::ssi($urlp,('symb'=>$symb));
		&Apache::lonnet::delenv('form.grade_target','form.textwidth');		    
		if ($flag_latex_header_remove ne 'NO') {
		    $texversion = &latex_header_footer_remove($texversion);
		} else {
		    $texversion =~ s/\\end{document}//;
		}
		$result .= $texversion;  
		$flag_latex_header_remove = 'YES';
	    }		
	}	    
	$result .= '\end{document}';
    } elsif ($choice eq 'All class print') { 
    #-- prints assignments for whole class or for selected students  
	$selectionmade = 5;
        my @students = ();
	for (my $i=0; $i<$ENV{'form.numberofstudents'};$i++) {
	    if ($ENV{'form.whomtoprint'.$i}=~/:/) {
		push @students,$ENV{'form.whomtoprint'.$i};
	    }
	}
	#where is the primary sequence containing current resource (the same for all students)?
	my $symbolic = &Apache::lonnet::symbread($ENV{'form.url'});
	my @sequence = split('___',$symbolic);
	my $primary_sequence = '/res/'.$sequence[0]; 	
	my @master_seq = &coming_from_hash($primary_sequence,$sequence[0]); 
        #loop over students
	my $flag_latex_header_remove = 'NO'; 
	my %moreenv;
	$moreenv{'form.textwidth'}=$LaTeXwidth;
	&Apache::lonnet::appenv(%moreenv);
	foreach my $person (@students) {
	    my $current_output = ''; 
	    my ($usersection,$username,$userdomain) = split /:/,$person;
	    my $fullname = &Apache::grades::get_fullname($username,$userdomain);
            #goes through all resources, checks if they are available for current student, and produces output   
	    foreach my $curresline (@master_seq)  {
		my ($curres,$symb) = split /&&/, $curresline;
                if ($curres=~ m/\.(problem|exam|quiz|assess|survey|form|library)/) {
		    my ($map,$id,$res_url) = split(/___/,$symb);
		    if (&Apache::lonnet::allowed('bre',$res_url)) {
			my $rendered = &Apache::loncommon::get_student_view($symb,$username,$userdomain,
                                                                        $ENV{'request.course.id'},'tex');
			if ($flag_latex_header_remove eq 'YES') {
			    $rendered = &latex_header_footer_remove($rendered);
			} else {
			    $rendered =~ s/\\end{document}//;
			}
			$current_output .= $rendered;
		    }
		    $flag_latex_header_remove = 'YES';
		}
	    }
	    if ($current_output=~/\\documentclass/) {
		my $courseidinfo = $ENV{'course.'.$ENV{'request.course.id'}.'.description'};
		$current_output =~ s/\\begin{document}/\\setlength{\\topmargin}{1cm}\\setlength{\\headheight}{1cm}\\setlength{\\headsep}{0.5cm}\\pagestyle{myheadings}\\markboth{}{{$courseidinfo  - $assignment}}\\begin{document}\\noindent\\textit{\\textbf{$fullname}}\\vskip 3 mm /;
	    } else {
		my $blanspages = '';
		for (my $j=0;$j<$ENV{'form.addedpages'};$j++) {$blanspages.='\clearpage\strut\clearpage';}
		$current_output = '\strut\\newline\\noindent\\makebox[\\textwidth/$number_of_columns][b]{\\hrulefill}\\newline\\noindent{\\tiny Printed from LON-CAPA\\copyright MSU{\\hfill} Licensed under GNU General Public License } \\vskip 3mm'.$blanspages.'\setcounter{page}{1}\noindent\parbox{\minipagewidth}{\noindent\textit{\textbf{'.$fullname.'}}\hskip 1.4in } \vskip 5 mm '.$current_output;
	    }
	    $result .= $current_output;
	    &Apache::lonnet::delenv('form.counter');
	}
	$result .= '\end{document}';
	&Apache::lonnet::delenv('form.textwidth');
    } elsif ($choice eq 'Subdirectory print') {      
    #prints selected problems from the subdirectory 
	$selectionmade = 6;
        my @list_of_files = ();
	for (my $i=0; $i<$ENV{'form.numberofproblems'};$i++) {
	    if ($ENV{'form.whattoprint'.$i}=~/^\//) {
		push @list_of_files,$ENV{'form.whattoprint'.$i};
	    }
	}	
	my $flag_latex_header_remove = 'NO';  
	for (my $i=0;$i<=$#list_of_files;$i++) {
	    my $urlp = $list_of_files[$i];
	    if ($urlp=~/\//) {
		my %moreenv;
		$moreenv{'form.grade_target'}='tex';
		$moreenv{'form.textwidth'}=$LaTeXwidth;
		&Apache::lonnet::appenv(%moreenv);
		if ($ENV{'request.role'}=~m/^au\./ or $ENV{'request.role'}=~m/^ca\./) { 
		    $urlp =~ s/\/home\/([^\/]*)\/public_html/\/~$1/; 
		}
		my $texversion=&Apache::lonnet::ssi($urlp);
		&Apache::lonnet::delenv('form.grade_target','form.textwidth');
                #this chunck is responsible for printing the path to problem
		my $newurlp = '';
		my $HowMany = length($urlp)*2;
		if ($HowMany > $LaTeXwidth) {
		    my @temporrary = split '/',$urlp;
		    my $HowManyNew = 0;
		    for (my $ii=0;$ii<=$#temporrary;$ii++) {
			if ($temporrary[$ii] ne '') {
			    $HowManyNew += length($temporrary[$ii])*2;
			    if ($HowManyNew < $LaTeXwidth ) {
				$newurlp .=  '/'.$temporrary[$ii];
			    } else {
				$HowManyNew = 0;
				$newurlp .=  '|\vskip -1 mm \noindent \verb|';
				$ii--;
			    }
			}
		    }
		}
		$texversion =~ s/(\\begin{minipage}{\\textwidth})/$1 {\\small\\noindent\\verb|$newurlp\|\\vskip 0 mm}/;
		if ($flag_latex_header_remove ne 'NO') {
		    $texversion = &latex_header_footer_remove($texversion);
		} else {
		    $texversion =~ s/\\end{document}//;
		}
		$result .= $texversion;
	    }
	    $flag_latex_header_remove = 'YES';  
	}
	$result .= '\end{document}';      	
    }
#-------------------------------------------------------- corrections for the different page formats
    $result = &page_format_transformation($papersize,$layout,$numberofcolumns,$choice,$result,$assignment);
    if ($layout eq 'CBI') {
        $laystyle = 'album';
    }
    $result = &latex_corrections($number_of_columns,$result);
    #changes page's parameters for the one column output 
    if ($ENV{'form.numberofcolumns'} == 1) {
	$result =~ s/\\textwidth= 9cm/\\textwidth= $ENV{'form.width'}/;
	$result =~ s/\\textheight 25\.9cm/\\textheight $ENV{'form.height'}/;
	$result =~ s/\\evensidemargin = -0\.57in/\\evensidemargin= $ENV{'form.leftmargin'}/;
	$result =~ s/\\oddsidemargin = -0\.57in/\\oddsidemargin= $ENV{'form.leftmargin'}/;
    }
#-- writing .tex file in prtspool 
    my $temp_file;
    my $filename = "/home/httpd/prtspool/$ENV{'user.name'}_$ENV{'user.domain'}_printout_".time."_".rand(10000000).".tex";
    unless ($temp_file = Apache::File->new('>'.$filename)) {
	$r->log_error("Couldn't open $filename for output $!");
	return SERVER_ERROR; 
    } 
    print $temp_file $result;
$r->print(<<FINALEND);
<meta http-equiv="Refresh" content="0; url=/cgi-bin/printout.pl?$filename&$laystyle&$numberofcolumns&$selectionmade">
</body>
</html>
FINALEND
}


sub coming_from_hash_whole {

    my $mainsequence = shift;
    my @resourcelist = ();
    my $mapid = $hash{'map_pc_'.$mainsequence};
    my $mapstart = $hash{'map_start_'.$mainsequence};
    my $mapfinish = $hash{'map_finish_'.$mainsequence};
    my $current_resource = $mapstart;
    while ($current_resource ne $mapfinish) {
	if ($hash{'src_'.$current_resource}=~/\.sequence$/) {
	    push @resourcelist,&coming_from_hash_whole($hash{'src_'.$current_resource});
	} else {
            $mainsequence =~ /\/res\/(.*)$/;
	    my $presymb = $1;
	    my $rid = $hash{'ids_'.$hash{'src_'.$current_resource}};
            if ($rid=~/,/) {
		my @rid = split /,/, $rid;
		foreach my $rid_element (@rid) {
		    if ($rid_element =~ m/^$mapid\.(\d*)/) {
			$rid = $1; 
			last;
		    }
		}
	    } else {
		$rid =~ m/^$mapid\.(\d*)/;
                $rid = $1;  
	    }
	    $hash{'src_'.$current_resource} =~ m/\/res\/(.*)$/;
	    my $symb = $presymb.'___'.$rid.'___'.$1;	    
	    push @resourcelist,$hash{'src_'.$current_resource}.'&&'.$symb;
	}
	$current_resource = $hash{'goesto_'.$hash{'to_'.$current_resource}};
    }
    return @resourcelist;
}


sub coming_from_hash {

    my ($mainsequence,$symb) = @_;
    my @resourcelist = ();
    my $mapid = $hash{'map_pc_'.$mainsequence};
    my $mapstart = $hash{'map_start_'.$mainsequence};
    my $mapfinish = $hash{'map_finish_'.$mainsequence};
    my ($presymb);
    if ($symb) {
	($presymb)=split(/___/,$symb);
    } else {
	$presymb=$mainsequence;
	$presymb=~s|^/res/||;
    }
    $presymb = $presymb.'___';
    my $current_resource = $mapstart;
    while ($current_resource ne $mapfinish) {
	if (not $hash{'src_'.$current_resource}=~/\.sequence$/) {
	    my $rid = $hash{'ids_'.$hash{'src_'.$current_resource}};
            if ($rid=~/,/) {
		my @rid = split /,/, $rid;
		foreach my $rid_element (@rid) {
		    if ($rid_element =~ m/^$mapid\.(\d*)/) {
			$rid = $1; 
			last;
		    }
		}
	    } else {
		$rid =~ m/^$mapid\.(\d*)/;
                $rid = $1;  
	    }
	    $hash{'src_'.$current_resource} =~ m/\/res\/(.*)$/;
	    $symb = $presymb.$rid.'___'.$1;
	    push @resourcelist,$hash{'src_'.$current_resource}.'&&'.$symb;
	} else {
	    push @resourcelist,&coming_from_hash($hash{'src_'.$current_resource});
	}
	$current_resource = $hash{'goesto_'.$hash{'to_'.$current_resource}};
    }
    #needs if final resource in the map (type="finish") contains something
    if (not $hash{'src_'.$current_resource}=~/\.sequence$/) {
		    my $rid = $hash{'ids_'.$hash{'src_'.$current_resource}};
            if ($rid=~/,/) {
		my @rid = split /,/, $rid;
		foreach my $rid_element (@rid) {
		    if ($rid_element =~ m/^$mapid\.(\d*)/) {
			$rid = $1; 
			last;
		    }
		}
	    } else {
		$rid =~ m/^$mapid\.(\d*)/;
                $rid = $1;  
	    }
	    $hash{'src_'.$current_resource} =~ m/\/res\/(.*)$/;
	    $symb = $presymb.$rid.'___'.$1;
	push @resourcelist,$hash{'src_'.$current_resource}.'&&'.$symb;
    } else {
	push @resourcelist,&coming_from_hash($hash{'src_'.$current_resource});
    }
    return @resourcelist;
}


sub latex_header_footer_remove {
    my $text = shift;
    $text =~ s/\\end{document}//;
    $text =~ s/\\documentclass([^&]*)\\begin{document}//;
    return $text;
}


sub character_chart {
    my $result = shift;	
    $result =~ s/&#0?0?7;//g;
    $result =~ s/&#0?0?9;//g;
    $result =~ s/&#0?10;//g;
    $result =~ s/&#0?13;//g;
    $result =~ s/&#0?32;/ /g;
    $result =~ s/&#0?33;/!/g;
    $result =~ s/&#0?34;/"/g;
    $result =~ s/&quot;/"/g;   #"
    $result =~ s/&#0?35;/\\#/g;
#    $result =~ s/&#0?36;/\\\$/g;
    $result =~ s/&#0?37;/\\%/g; 
    $result =~ s/&#0?38;/\\&/g; 
    $result =~ s/&amp;/\\&/g;
    $result =~ s/&#0?39;/'/g;
    $result =~ s/&#0?40;/(/g;
    $result =~ s/&#0?41;/)/g;
    $result =~ s/&#0?42;/\*/g;
    $result =~ s/&#0?43;/\+/g;
    $result =~ s/&#0?44;/,/g;
    $result =~ s/&#0?45;/-/g;
    $result =~ s/&#0?46;/\./g;
    $result =~ s/&#0?47;/\//g;
    $result =~ s/&#0?48;/0/g;
    $result =~ s/&#0?49;/1/g;
    $result =~ s/&#0?50;/2/g;
    $result =~ s/&#0?51;/3/g;
    $result =~ s/&#0?52;/4/g;
    $result =~ s/&#0?53;/5/g;
    $result =~ s/&#0?54;/6/g;
    $result =~ s/&#0?55;/7/g;
    $result =~ s/&#0?56;/8/g;
    $result =~ s/&#0?57;/9/g;
    $result =~ s/&#0?58;/:/g;
    $result =~ s/&#0?59;/;/g;
    $result =~ s/&#0?60;/\$<\$/g;
    $result =~ s/&lt;/\$<\$/g;
    $result =~ s/&#0?61;/\$=\$/g;
    $result =~ s/&#0?62;/\$>\$/g;
    $result =~ s/&gt;/\$>\$/g;
    $result =~ s/&#0?63;/?/g;
#    $result =~ s/&#0?64;//g;
    $result =~ s/&#0?65;/A/g;
    $result =~ s/&#0?66;/B/g;
    $result =~ s/&#0?67;/C/g;
    $result =~ s/&#0?68;/D/g;
    $result =~ s/&#0?69;/E/g;
    $result =~ s/&#0?70;/F/g;
    $result =~ s/&#0?71;/G/g;
    $result =~ s/&#0?72;/H/g;
    $result =~ s/&#0?73;/I/g;
    $result =~ s/&#0?74;/J/g;
    $result =~ s/&#0?75;/K/g;
    $result =~ s/&#0?76;/L/g;
    $result =~ s/&#0?77;/M/g;
    $result =~ s/&#0?78;/N/g;
    $result =~ s/&#0?79;/O/g;
    $result =~ s/&#0?80;/P/g;
    $result =~ s/&#0?81;/Q/g;
    $result =~ s/&#0?82;/R/g;
    $result =~ s/&#0?83;/S/g;
    $result =~ s/&#0?84;/T/g;
    $result =~ s/&#0?85;/U/g;
    $result =~ s/&#0?86;/V/g;
    $result =~ s/&#0?87;/W/g;
    $result =~ s/&#0?88;/X/g;
    $result =~ s/&#0?89;/Y/g;
    $result =~ s/&#0?90;/Z/g;
    $result =~ s/&#0?91;/[/g;
    $result =~ s/&#0?92;/\\/g;
    $result =~ s/&#0?93;/]/g;
#    $result =~ s/&#0?94;//g;
#    $result =~ s/&#0?95;//g;
    $result =~ s/&#0?96;/`/g;
    $result =~ s/&#0?97;/a/g;
    $result =~ s/&#0?98;/b/g;
    $result =~ s/&#0?99;/c/g;
    $result =~ s/&#100;/d/g;
    $result =~ s/&#101;/e/g;
    $result =~ s/&#102;/f/g;
    $result =~ s/&#103;/g/g;
    $result =~ s/&#104;/h/g;
    $result =~ s/&#105;/i/g;
    $result =~ s/&#106;/j/g;
    $result =~ s/&#107;/k/g;
    $result =~ s/&#108;/l/g;
    $result =~ s/&#109;/m/g;
    $result =~ s/&#110;/n/g;
    $result =~ s/&#111;/o/g;
    $result =~ s/&#112;/p/g;
    $result =~ s/&#113;/q/g;
    $result =~ s/&#114;/r/g;
    $result =~ s/&#115;/s/g;
    $result =~ s/&#116;/t/g;
    $result =~ s/&#117;/u/g;
    $result =~ s/&#118;/v/g;
    $result =~ s/&#119;/w/g;
    $result =~ s/&#120;/x/g;
    $result =~ s/&#121;/y/g;
    $result =~ s/&#122;/z/g;
    $result =~ s/&#123;/\\{/g;
    $result =~ s/&#124;/\|/g;
    $result =~ s/&#125;/\\}/g;
    $result =~ s/&#126;/\~/g;
    $result =~ s/&#130;/,/g;
#    $result =~ s/&#131;//g;
    $result =~ s/&#132;/''/g;
    $result =~ s/&#133;/\$\\ldots\$/g;
    $result =~ s/&#134;/\$\\dagger\$/g;
    $result =~ s/&#135;/\$\\ddagger\$/g;
#    $result =~ s/&#136;//g;
#    $result =~ s/&#137;//g;
#    $result =~ s/&#138;//g;
    $result =~ s/&#139;/\$<\$/g;
#    $result =~ s/&#140;//g;
    $result =~ s/&#145;/`/g;
    $result =~ s/&#146;/'/g;
    $result =~ s/&#147;/``/g;
    $result =~ s/&#148;/''/g;
    $result =~ s/&#149;/\$\\bullet\$/g;
#    $result =~ s/&#150;//g;
#    $result =~ s/&#151;//g;
    $result =~ s/&#152;/~/g;
#    $result =~ s/&#153;//g;
#    $result =~ s/&#154;//g;
    $result =~ s/&#155;/\$>\$/g;
    $result =~ s/&#156;/\\{\\oe\\}/g;
    $result =~ s/&#159;/\\"\\{Y\\}/g;
    $result =~ s/&#160;//g;
    $result =~ s/&nbsp;//g;
    $result =~ s/&#161;/!`/g;
    $result =~ s/&iexcl;/!`/g; #`
#    $result =~ s/&#162;//g;
#    $result =~ s/&cent;//g;
    $result =~ s/&#163;/\\pounds/g; 
    $result =~ s/&pound;/\\pounds/g;
#    $result =~ s/&#164;//g;
#    $result =~ s/&curren;//g;
#    $result =~ s/&#165;//g;
#    $result =~ s/&yen;//g;
#    $result =~ s/&#166;//g;
#    $result =~ s/&brvbar;//g;
#    $result =~ s/&#167;//g;
#    $result =~ s/&sect;//g;
#    $result =~ s/&#168;//g;
#    $result =~ s/&uml;//g;
    $result =~ s/&#169;/\\copyright/g;
    $result =~ s/&copy;/\\copyright/g;
#    $result =~ s/&#170;//g;
#    $result =~ s/&ordf;//g;
#    $result =~ s/&#171;//g;
#    $result =~ s/&laquo;//g;
    $result =~ s/&#172;/\$\\neg\$/g;
    $result =~ s/&not;/\$\\neg\$/g;
#    $result =~ s/&#173;//g;
#    $result =~ s/&shy;//g;
#    $result =~ s/&#174;//g;
#    $result =~ s/&reg;//g;
#    $result =~ s/&#175;//g;
#    $result =~ s/&macr;//g;
    $result =~ s/&#176;/\$^{\\circ}\$/g;
    $result =~ s/&deg;/\$^{\\circ}\$/g;
    $result =~ s/&#177;/\$\\pm\$/g;
    $result =~ s/&plusmn;/\$\\pm\$/g;
    $result =~ s/&#178;/\$^2\$/g;
    $result =~ s/&sup2;/\$^2\$/g;
    $result =~ s/&#179;/\$^3\$/g;
    $result =~ s/&sup3;/\$^3\$/g;
#    $result =~ s/&#180;//g;
#    $result =~ s/&acute;//g;
    $result =~ s/&#181;/\$\\mu\$/g;
    $result =~ s/&micro;/\$\\mu\$/g;
    $result =~ s/&#182;/\\P/g;
    $result =~ s/&para;/\\P/g;
    $result =~ s/&#183;/\$\\cdot\$/g;
    $result =~ s/&middot;/\$\\cdot\$/g;
#    $result =~ s/&#184;//g;
#    $result =~ s/&cedil;//g;
    $result =~ s/&#185;/\$^1\$/g;
    $result =~ s/&sup1;/\$^1\$/g;
#    $result =~ s/&#186;//g;
#    $result =~ s/&ordm;//g;
#    $result =~ s/&#187;//g;
#    $result =~ s/&raquo;//g;
#    $result =~ s/&#188;//g;
#    $result =~ s/&frac14;//g;
#    $result =~ s/&#189;//g;
#    $result =~ s/&frac12;//g;
#    $result =~ s/&#190;//g;
#    $result =~ s/&frac34;//g;
    $result =~ s/&#191;/?`/g;   
    $result =~ s/&iquest;/?`/g;      #`
    $result =~ s/&#192;/\\`{A}/g; 
    $result =~ s/&Agrave;/\\`{A}/g;  #` 
    $result =~ s/&#193;/\\'{A}/g; 
    $result =~ s/&Aacute;/\\'{A}/g;  #'
    $result =~ s/&#194;/\\^{A}/g;
    $result =~ s/&Acirc;/\\^{A}/g;
    $result =~ s/&#195;/\\~{A}/g;
    $result =~ s/&Atilde;/\\~{A}/g;
    $result =~ s/&#196;/\\"{A}/g; 
    $result =~ s/&Auml;/\\"{A}/g;    #"
    $result =~ s/&#197;/{\\AA}/g;
    $result =~ s/&Aring;/{\\AA}/g;
    $result =~ s/&#198;/{\\AE}/g;
    $result =~ s/&AElig;/{\\AE}/g;
#    $result =~ s/&#199;//g;
#    $result =~ s/&Ccedil;//g;
    $result =~ s/&#200;/\\`{E}/g;  
    $result =~ s/&Egrave;/\\`{E}/g;  #`
    $result =~ s/&#201;/\\'{E}/g;    #'
    $result =~ s/&Eacute;/\\'{E}/g;  #'
    $result =~ s/&#202;/\\^{E}/g;
    $result =~ s/&Ecirc;/\\^{E}/g;
    $result =~ s/&#203;/\\`{E}/g;
    $result =~ s/&Euml;/\\`{E}/g;    #`
    $result =~ s/&#204;/\\`{I}/g;
    $result =~ s/&Igrave;/\\`{I}/g;  #`
    $result =~ s/&#205;/\\'{I}/g;    
    $result =~ s/&Iacute;/\\'{I}/g;  #'
    $result =~ s/&#206;/\\^{I}/g;
    $result =~ s/&Icirc;/\\^{I}/g;
    $result =~ s/&#207;/\\"{I}/g;    
    $result =~ s/&Iuml;/\\"{I}/g;    #"
#    $result =~ s/&#208;//g;
#    $result =~ s/&ETH;//g;
    $result =~ s/&#209;/\\~{N}/g;
    $result =~ s/&Ntilde;/\\~{N}/g;
    $result =~ s/&#210;/\\`{O}/g;
    $result =~ s/&Ograve;/\\`{O}/g;  #`
    $result =~ s/&#211;/\\'{O}/g;
    $result =~ s/&Oacute;/\\'{O}/g;  #'
    $result =~ s/&#212;/\\^{O}/g;
    $result =~ s/&Ocirc;/\\^{O}/g;
    $result =~ s/&#213;/\\~{O}/g;
    $result =~ s/&Otilde;/\\~{O}/g;
    $result =~ s/&#214;/\\"{O}/g;    
    $result =~ s/&Ouml;/\\"{O}/g;    #"
    $result =~ s/&#215;/\$\\times\$/g;
    $result =~ s/&times;/\$\\times\$/g;
    $result =~ s/&#216;/{\\O}/g;
    $result =~ s/&Oslash;/{\\O}/g;
    $result =~ s/&#217;/\\`{U}/g;    
    $result =~ s/&Ugrave;/\\`{U}/g;  #`
    $result =~ s/&#218;/\\'{U}/g;    #'
    $result =~ s/&Uacute;/\\'{U}/g;  #'
    $result =~ s/&#219;/\\^{U}/g;
    $result =~ s/&Ucirc;/\\^{U}/g;
    $result =~ s/&#220;/\\"{U}/g;    #"
    $result =~ s/&Uuml;/\\"{U}/g;    #"
    $result =~ s/&#221;/\\'{Y}/g;
    $result =~ s/&Yacute;/\\'{Y}/g;  #'
#    $result =~ s/&#222;//g;
#    $result =~ s/&THORN;//g;
#    $result =~ s/&#223;//g;
#    $result =~ s/&szlig;//g;
    $result =~ s/&#224;/\\`{a}/g;
    $result =~ s/&agrave;/\\`{a}/g;  #`
    $result =~ s/&#225;/\\'{a}/g;
    $result =~ s/&aacute;/\\'{a}/g;  #'
    $result =~ s/&#226;/\\^{a}/g;
    $result =~ s/&acirc;/\\^{a}/g;
    $result =~ s/&#227;/\\~{a}/g;
    $result =~ s/&atilde;/\\~{a}/g;
    $result =~ s/&#228;/\\"{a}/g;
    $result =~ s/&auml;/\\"{a}/g;    #"
    $result =~ s/&#229;/{\\aa}/g;
    $result =~ s/&aring;/{\\aa}/g;
    $result =~ s/&#230;/{\\ae}/g;
    $result =~ s/&aelig;/{\\ae}/g;
#    $result =~ s/&#231;//g;
#    $result =~ s/&ccedil;//g;
    $result =~ s/&#232;/\\`{e}/g;
    $result =~ s/&egrave;/\\`{e}/g;  #`
    $result =~ s/&#233;/\\'{e}/g;
    $result =~ s/&eacute;/\\'{e}/g;  #'
    $result =~ s/&#234;/\\^{e}/g;
    $result =~ s/&ecirc;/\\^{e}/g;
    $result =~ s/&#235;/\\"{e}/g;
    $result =~ s/&euml;/\\"{e}/g;    #"
    $result =~ s/&#236;/\\`{i}/g;
    $result =~ s/&igrave;/\\`{i}/g;  #`
    $result =~ s/&#237;/\\'{i}/g;
    $result =~ s/&iacute;/\\'{i}/g;  #'
    $result =~ s/&#238;/\\^{i}/g;
    $result =~ s/&icirc;/\\^{i}/g;
    $result =~ s/&#239;/\\"{i}/g;
    $result =~ s/&iuml;/\\"{i}/g;    #"
#    $result =~ s/&#240;//g;
#    $result =~ s/&eth;//g;
    $result =~ s/&#241;/\\~{n}/g;
    $result =~ s/&ntilde;/\\~{n}/g;
    $result =~ s/&#242;/\\`{o}/g;
    $result =~ s/&ograve;/\\`{o}/g;  #`
    $result =~ s/&#243;/\\'{o}/g;
    $result =~ s/&oacute;/\\'{o}/g;  #'
    $result =~ s/&#244;/\\^{o}/g;
    $result =~ s/&ocirc;/\\^{o}/g;
    $result =~ s/&#245;/\\~{o}/g;
    $result =~ s/&otilde;/\\~{o}/g;
    $result =~ s/&#246;/\\"{o}/g;
    $result =~ s/&ouml;/\\"{o}/g;    #"
    $result =~ s/&#247;/\$\\div\$/g;
    $result =~ s/&divide;/\$\\div\$/g;
    $result =~ s/&#248;/{\\o}/g;
    $result =~ s/&oslash;/{\\o}/g;
    $result =~ s/&#249;/\\`{u}/g; 
    $result =~ s/&ugrave;/\\`{u}/g;  #` 
    $result =~ s/&#250;/\\'{u}/g;
    $result =~ s/&uacute;/\\'{u}/g;  #'
    $result =~ s/&#251;/\\^{u}/g;
    $result =~ s/&ucirc;/\\^{u}/g;
    $result =~ s/&#252;/\\"{u}/g;
    $result =~ s/&uuml;/\\"{u}/g;    #"
    $result =~ s/&#253;/\\'{y}/g;
    $result =~ s/&yacute;/\\'{y}/g;  #'
#    $result =~ s/&#254;//g;
#    $result =~ s/&thorn;//g;
    $result =~ s/&#255;/\\"{y}/g;
    $result =~ s/&yuml;/\\"{y}/g;    #"
    $result =~ s/&#952;/\$\\theta\$/g; #converts theta from html into tex
    return $result;
}


    sub page_format {
	my ($papersize,$layout,$numberofcolumns) = @_; 
	my ($textwidth,$textheight,$oddoffset,$evenoffset) = (0,0,0,0);
	if ($papersize=~/Letter/) {
	    if ($layout eq 'CAPA') {
		if ($numberofcolumns == 1) {
		    $textwidth = '18 cm';
		    $textheight = '25.9 cm';
		    $oddoffset = '-0.57 in';
		    $evenoffset = '-0.57 in';
		} elsif ($numberofcolumns == 2) {
		    $textwidth = '93 mm';
		    $textheight = '25.9 cm';
		    $oddoffset = '-0.57 in';
		    $evenoffset = '-0.57 in';
		}
	    } elsif ($layout eq 'CBI') {
		if ($numberofcolumns eq '1') {
		    $textwidth = '8.8 in';
		    $textheight = '6.8 in';
		    $oddoffset = '-40 pt';
		    $evenoffset = '-60 pt';
		} elsif ($numberofcolumns == 2) {
		    $textwidth = '4.2 in';
		    $textheight = '6.8 in';
		    $oddoffset = '-40 pt';
		    $evenoffset = '-60 pt';
		}
	    }
#    } elsif($papersize=~/Legal/) {
#    } elsif($papersize=~/Ledger/) {
#    } elsif($papersize=~/Executive/) {
    } elsif($papersize=~/A4/) {
	    if ($layout eq 'CAPA') {
		if ($numberofcolumns == 1) {
		    $textwidth = '18 cm';
		    $textheight = '28 cm';
		    $oddoffset = '-0.57 in';
		    $evenoffset = '-0.57 in';
		} elsif ($numberofcolumns == 2) {
		    $textwidth = '96 mm';
		    $textheight = '2 cm';
		    $oddoffset = '-0.57 in';
		    $evenoffset = '-0.57 in';
		}
	    } elsif ($layout eq 'CBI') {
		if ($numberofcolumns eq '1') {
		    $textwidth = '8.5 in';
		    $textheight = '7.7 in';
		    $oddoffset = '-40 pt';
		    $evenoffset = '-60 pt';
		} elsif ($numberofcolumns == 2) {
		    $textwidth = '3.9 in';
		    $textheight = '7.7 in';
		    $oddoffset = '-40 pt';
		    $evenoffset = '-60 pt';
		}
	    }
#    } elsif($papersize=~/A3/) {
#    } elsif($papersize=~/A2/) {
#    } elsif($papersize=~/A5/) {
#    } elsif($papersize=~/A6/) {
	}
	return $textwidth,$textheight,$oddoffset,$evenoffset;
    }


sub page_format_transformation {
	my ($papersize,$layout,$numberofcolumns,$choice,$text,$assignment) = @_; 
	my ($textwidth,$textheight,$oddoffset,$evenoffset) = &page_format($papersize,$layout,$numberofcolumns);
	my $courseidinfo = $ENV{'course.'.$ENV{'request.course.id'}.'.description'};	
	if ($layout eq 'CBI') {
	    $text =~ s/\\begin{document}/\\setlength{\\oddsidemargin}{$oddoffset}\\setlength{\\evensidemargin}{$evenoffset}\\setlength{\\topmargin}{200pt}\\setlength{\\textwidth}{$textwidth}\\setlength{\\textheight}{$textheight}\\setlength{\\parindent}{20pt}\\setlength{\\marginparwidth}{90pt}\\setlength{\\textfloatsep}{8pt plus 2\.0pt minus 4\.0pt}\\newlength{\\minipagewidth}\\setlength{\\minipagewidth}{\\textwidth\/\$number_of_columns-0\.2cm} \\begin{document}\\setcounter{page}{1}\\noindent\\parbox{\\minipagewidth}{\\noindent\\fbox{\\textbf{$ENV{'environment.firstname'} $ENV{'environment.lastname'}}} \\hfill  $courseidinfo} \\vskip 5 mm /;
	} elsif ($layout eq 'CAPA') {
 	    if ($choice ne 'All class print') { 
		$text =~ s/\\begin{document}/\\textheight $textheight\\oddsidemargin = $evenoffset\\evensidemargin = $evenoffset\\textwidth= $textwidth\\newlength{\\minipagewidth}\\setlength{\\minipagewidth}{\\textwidth\/\$number_of_columns-0\.2cm}\\renewcommand{\\ref}{\\keephidden\}\\setlength{\\topmargin}{1cm}\\setlength{\\headheight}{1cm}\\setlength{\\headsep}{0.5cm}\\markboth{}{\\textbf{$ENV{'environment.firstname'} $ENV{'environment.lastname'}} $courseidinfo - $assignment}\\pagestyle{myheadings}\\begin{document}\\voffset=-1\.8cm\\setcounter{page}{1}/;
	    } else {
		$text =~ s/\\begin{document}/\\setlength{\\textheight}{$textheight}\\setlength{\\oddsidemargin}{$oddoffset}\\setlength{\\evensidemargin}{$evenoffset}\\setlength{\\textwidth}{$textwidth}\\newlength{\\minipagewidth}\\setlength{\\minipagewidth}{\\textwidth\/\$number_of_columns-0\.2cm}\\renewcommand{\\ref}{\\keephidden\}\\begin{document}\\voffset=-1\.8cm\\setcounter{page}{1}  \\vskip 5 mm /;
	    }
	}
	return $text;
}


sub page_cleanup {
    my $result = shift;	
 
    $result =~ m/\\end{document}(\d*)$/;
    my $number_of_columns = $1;
    my $insert = '{';
    for (my $id=1;$id<=$number_of_columns;$id++) { $insert .='l'; }
    $insert .= '}';
    $result =~ s/(\\begin{longtable})INSERTTHEHEADOFLONGTABLE\\endfirsthead\\endhead/$1$insert/g;
    $result =~ s/&\s*REMOVETHEHEADOFLONGTABLE\\\\/\\\\/g;
    return $result,$number_of_columns;
}


sub details_for_menu {

    my $name_of_resourse = $hash{'title_'.$hash{'ids_'.$ENV{'form.postdata'}}};
    my $symbolic = &Apache::lonnet::symbread($ENV{'form.postdata'});
    my ($map,$id,$resource)=split(/___/,$symbolic);
    my $name_of_sequence = $hash{'title_'.$hash{'ids_/res/'.$map}};
    if ($name_of_sequence =~ /^\s*$/) {
      $map =~ m|([^/]+)$|;
      $name_of_sequence = $1;
    }
    my $name_of_map = $hash{'title_'.$hash{'ids_/res/'.$ENV{'request.course.uri'}}};
    if ($name_of_map =~ /^\s*$/) {
      $ENV{'request.course.uri'} =~ m|([^/]+)$|;
      $name_of_map = $1;
    }  
    return ($name_of_resourse,$name_of_sequence,$name_of_map);

}


sub latex_corrections {

    my ($number_of_columns,$result) = @_;

    $result =~ s/\\includegraphics{/\\includegraphics\[width=\\minipagewidth\]{/g;
    $result =~ s/\$number_of_columns/$number_of_columns/g;
    $result =~ s/(\\end{document})/\\strut\\newline\\noindent\\makebox\[\\textwidth\/$number_of_columns\]\[b\]{\\hrulefill}\\newline\\noindent\\tiny Printed from LON-CAPA\\copyright MSU{\\hfill} Licensed under GNU General Public License  $1/;
    $result =~ s/(\\end{longtable}\s*)(\\strut\\newline\\noindent\\makebox\[\\textwidth\/$number_of_columns\]\[b\]{\\hrulefill})/$2$1/g;
    $result =~ s/(\\end{longtable}\s*)\\strut\\newline/$1/g;
#-- LaTeX corrections     
    my $first_comment = index($result,'<!--',0);
    while ($first_comment != -1) {
	my $end_comment = index($result,'-->',$first_comment);
	substr($result,$first_comment,$end_comment-$first_comment+3) = '';
	$first_comment = index($result,'<!--',$first_comment);
    }
    $result =~ s/^\s+$//gm; #remove empty lines
    $result =~ s/(\s)(\s+)/$1/g; #removes more than one empty space
    $result =~ s/\\\\\s*\\vskip/\\vskip/gm;
    $result =~ s/\\\\\s*\\noindent\s*(\\\\)+/\\\\\\noindent /g;
    $result =~ s/{\\par }\s*\\\\/\\\\/gm;
	$result =~ s/\\\\\s+\[/ \[/g;
    $result =~ s/\b__+\b/\\makebox\[1 cm\]\[b\]{\\hrulefill}/g;
    #conversion of html characters to LaTeX equivalents
    if ($result =~ m/&(\w+|#\d+);/) {
	$result = &character_chart($result);
    }
    $result =~ s/(\\end{tabular})\s*\\vskip 0 mm/$1/g;
    $result =~ s/(\\begin{enumerate})\s*\\noindent/$1/g;

    return $result;
}


sub handler {

    my $r = shift;

    my $loaderror=&Apache::lonnet::overloaderror($r);
    if ($loaderror) { return $loaderror; }
    $loaderror=
       &Apache::lonnet::overloaderror($r,
         $ENV{'course.'.$ENV{'request.course.id'}.'.home'});
    if ($loaderror) { return $loaderror; }

    $r->content_type('text/html');
    $r->send_http_header;
    $r->print(&Apache::loncommon::bodytag("Printing"));

    if ($ENV{'request.course.id'}) {
	my $fn=$ENV{'request.course.fn'};
	tie(%hash,'GDBM_File',"$fn.db",&GDBM_READER(),0640);
    }

#-- start form
    &headerform($r);
#-- menu for output
    unless  ($ENV{'form.phase'}) {
	&menu_for_output($r);
    }
#-- additional menu for class printing
     if ($ENV{'form.phase'} eq 'two') {
	 if($ENV{'form.choice'} eq 'Standard LaTeX output for whole primary sequence') {
	     &sequence_content_menu(0,$r);
	 } elsif($ENV{'form.choice'} eq 'Standard LaTeX output for the primary sequence') {
	     &sequence_content_menu(1,$r);
	 } elsif($ENV{'form.choice'} eq 'All class print') {
	     &additional_class_menu($r);
	 } elsif($ENV{'form.choice'} eq 'Subdirectory print') {
	     &problem_choice_menu($r);
	 } else {
	     $ENV{'form.phase'} = 'three';
	 }
     }
#-- additional menu for page layout (one column case)
    if ($ENV{'form.phase'} eq 'three') {
	if($ENV{'form.numberofcolumns'} == 1) {
	    &additional_print_menu($r);
	} else {
	    $ENV{'form.phase'} = 'four';
	}
    }
#-- core part 
    if ($ENV{'form.phase'} eq 'four') {
	&output_data($r);
    }	
    untie %hash;
    return OK;
   
} 


1;
__END__

